program lies;
uses panning,dos,crt,maus,joystick,printer;
type liestyp=record
        kennung:string[11];
        textattribut:byte;
        menuattribut:byte;
        infoattribut:byte;
        markiertattribut:byte;
        usejoy:boolean;
        usemaus:boolean;
        joykalib:array[0..1,0..1] of integer;
                      {    0=Oben/Links 1=Unten/Rechts}
                      { 0=Links/Rechts 1=Hoch/Runter   }
        zeilenpause:boolean;
        BlockLesen:Boolean;
      end;
const liesopt:liestyp=(kennung:'LIESKEN 1.0';
                       textattribut:(blue shl 4)+yellow;
                       menuattribut:(cyan shl 4)+darkgray;
                       infoattribut:(cyan shl 4)+lightgreen;
                       markiertattribut:(blue shl 4)+lightgreen;
                       usejoy:false;
                       usemaus:false;
                       joykalib:((0,1000),(0,1000));
                       zeilenpause:false;
                       BlockLesen:true
                        );

const ytextmax=26;
      xtextmax=160;
      xtextnorm=80;
      ytextnorm=24;
      maxzeile=16000;
      maxblock=65000;
      onlybuf=false;
      bufandscreen=true;
      druckanfang:longint=1;
      druckende:longint=0;
      search:string[25]='';
      groskleinbeacht:boolean=false;
      vor:boolean=true;
type Tstrzeile=string[xtextmax];
     Pzeile=^Tstrzeile;
     PTex=^TTex;
     TTex=record
            start,maxzeile:word;
            s:array[0..maxzeile] of PZeile;
            next:PTex;
          end;
     PBlock=^TBlock;
     TBlock=record
              b:array[0..maxblock] of byte;
              next:PBlock;
            end;
     TBildPuffer=array[0..pred(ytextmax),0..pred(xtextmax)] of word;
     TTextinfo=record
             name:string[12];
             datumzeit:datetime;
             grose:longint;
             zeilen:longint;
           end;
const y:longint=0;
      line:integer=0;
      col:integer=0;
      aktbild:byte=0;
      zeilengesamt:longint=0;
      joy:byte=2;
      mouse:boolean=false;
      block:pblock=nil;
      tex:PTex=nil;
      StartSegment=$b814;{160 Words Platz am Anfang fr Statuszeile}
      StatusStartSegment=$b800;
var slinepc,linemax,colmax:integer;
    textinfo:Ttextinfo;
    suche:searchrec;
    neu:boolean;
    BildPuf:TbildPuffer;
    altmenuattribut:byte;
    altinfoattribut:byte;

procedure crtreset;
var regs:registers;
begin
  with regs do begin
    ax:=3;intr($10,regs);
  end;
end;

procedure error(s:string);
begin
  crtreset;
  writeln(s);
  halt(1);
end;

function leseReadln(name:string;var suche:searchrec;var neu:boolean):boolean;
{ Liest text mit Readln}
var f:text;
    akt:ptex;
    n,zeilemsb,zeilelsb:word;
    ok:boolean;
    hilf:PTex;
    ersteslesen:boolean;
    dir:dirstr;
    ext:extstr;
    buf:string;
    

  procedure ersetzte(c:char;s:string;var buf:string);
  var pos8:byte;
  begin
    pos8:=pos(c,buf);
    while pos8>0 do begin
      insert(s,buf,succ(pos8));
      delete(buf,pos8,1);
      pos8:=pos(c,buf);
    end;
  end;

  procedure disposestr(p:PZeile);
  begin
    if p<>nil then freemem(p,succ(length(p^)));
  end;

  function newstr(s:string):PZeile;
  var hps:pointer;
  begin
    if (maxavail<succ(length(s))) then
    newstr:=nil
    else begin
      getmem(hps,succ(length(s)));
      move(s[0],hps^,succ(length(s)));
      newstr:=hps;
    end;
  end;

begin
  y:=0;
  line:=0;
  col:=0;
  aktbild:=0;
  zeilengesamt:=0;
  FSplit(name,dir,suche.name,ext);
  suche.name:=suche.name+'.'+ext;
  ersteslesen:=neu;
  if neu then begin
    findfirst(name,archive,suche);
    neu:=false;
  end else begin
    n:=0;
    while (tex<>nil) and (tex^.s[n]<>nil) do begin
      disposestr(tex^.s[n]);
      inc(n);
      if n>maxzeile then begin
        n:=0;
        hilf:=tex;
        tex:=tex^.next;
        dispose(hilf);
      end;
    end;
    if tex<>nil then dispose(tex);
    findnext(suche);
  end;
  if doserror=0 then begin
    lesereadln:=true;
    textinfo.name:=suche.name;
    textinfo.grose:=suche.size;
    unpacktime(suche.time,textinfo.datumzeit);
    assign(f,dir+suche.name);
    reset(f);
    new(tex);
    akt:=tex;
    akt^.start:=0;
    zeilemsb:=0;
    zeilelsb:=0;
    ok:=true;
    while (not eof(f)) and (maxavail>256) and ok do begin
      readln(f,buf);
      ersetzte(#9,'        ',buf);
      akt^.s[zeilelsb]:=newstr(buf);
      inc(zeilengesamt);
      inc(zeilelsb);
      if zeilelsb>maxzeile then begin
        akt^.maxzeile:=maxzeile;
        zeilelsb:=0;
        inc(zeilemsb);
        if maxavail>sizeof(akt^) then begin
          new(akt^.next);
          akt:=akt^.next;
          akt^.start:=zeilemsb;
          ok:=true;
        end else ok:=false;
      end;
    end;
    akt^.maxzeile:=pred(zeilelsb);
    textinfo.zeilen:=zeilengesamt;
    if akt^.maxzeile<ytextnorm then begin
      akt^.maxzeile:=ytextnorm;
      zeilengesamt:=26;
    end;
    akt^.next:=nil;
    for n:=zeilelsb to maxzeile do akt^.s[n]:=nil;
  end else begin
    if ersteslesen then error('Text nicht gefunden');
    lesereadln:=false;
  end;
end;

function leseBlock(name:string;var suche:searchrec;var neu:boolean):boolean;
{liest jede Datei mit BlockRead}
var f:file;
    akt:ptex;
    n,zeilemsb,zeilelsb,versatz,lange:word;
    l:byte;
    ok:boolean;
    hilf:PTex;
    hblock:Pblock;
    ersteslesen,neuersatz:boolean;
    dir:dirstr;
    ext:extstr;
    buf:string;
begin
  y:=0;
  line:=0;
  col:=0;
  aktbild:=0;
  zeilengesamt:=0;
  FSplit(name,dir,suche.name,ext);
  suche.name:=suche.name+'.'+ext;
  ersteslesen:=neu;
  if neu then begin
    findfirst(name,archive,suche);
    neu:=false;
  end else begin
    while (tex<>nil) do begin
      hilf:=tex;
      tex:=tex^.next;
      dispose(hilf);
    end;
    while (block<>nil) do begin
      hblock:=block;
      block:=block^.next;
      dispose(hblock);
    end;
    findnext(suche);
  end;
  if doserror=0 then begin
    leseblock:=true;
    textinfo.name:=suche.name;
    textinfo.grose:=suche.size;
    unpacktime(suche.time,textinfo.datumzeit);
    assign(f,dir+suche.name);
    reset(f,1);
    new(tex);
    akt:=tex;
    akt^.start:=0;
    zeilemsb:=0;
    zeilelsb:=0;
    ok:=true;
    versatz:=1;
    new(block);
    block^.next:=nil;
    while (suche.size>0) and (maxavail>65535) and ok do begin
      if suche.size>sizeof(block^.b)-versatz then begin
        blockread(f,block^.b[versatz],sizeof(block^.b)-versatz);
        dec(suche.size,sizeof(block^.b)-versatz);
        lange:=sizeof(block^.b)-versatz;
      end else begin
        blockread(f,block^.b[versatz],suche.size);
        lange:=suche.size;
        suche.size:=0;
      end;
      n:=0;
      neuersatz:=true;
      while (n<lange) and ok do begin
        if neuersatz then akt^.s[zeilelsb]:=@block^.b[n];
        akt^.s[zeilelsb]^[0]:=#0;
        l:=0;
        while (block^.b[n]<>13) and (l<xtextmax) and (n<lange) do begin
          inc(l);
          inc(n);
        end;
        if (block^.b[n]<>13) then inc(byte(akt^.s[zeilelsb]^[0]),l)
        else inc(byte(akt^.s[zeilelsb]^[0]),pred(l));
        if (n<lange) and (block^.b[succ(n)]=10) then inc(n);
        if (n<lange) or (block^.b[n]=10) or (block^.b[n]=13) then begin
          neuersatz:=true;
          inc(zeilengesamt);
          inc(zeilelsb);
          if zeilelsb>maxzeile then begin
            akt^.maxzeile:=maxzeile;
            zeilelsb:=0;
            inc(zeilemsb);
            if maxavail>sizeof(akt^) then begin
              new(akt^.next);
              akt:=akt^.next;
              akt^.start:=zeilemsb;
              ok:=true;
            end else ok:=false;
          end;
        end else neuersatz:=false;
      end;
      if suche.size>0 then begin
        versatz:=lange-n;
        if (versatz=0) and (block^.b[n]=10) then versatz:=1;
        new(hblock);
        hblock^.next:=block;
        block:=hblock;
        move(block^.next^.b[n],block^.b,versatz);
      end;
    end;
    akt^.maxzeile:=pred(zeilelsb);
    textinfo.zeilen:=zeilengesamt;
    if akt^.maxzeile<ytextnorm then begin
      akt^.maxzeile:=ytextnorm;
      zeilengesamt:=26;
    end;
    akt^.next:=nil;
    for n:=zeilelsb to maxzeile do akt^.s[n]:=nil;
  end else begin
    if ersteslesen then error('Text nicht gefunden');
    leseblock:=false;
  end;
end;

function leseText(name:string;var suche:searchrec;var neu:boolean):boolean;
begin
  if liesopt.BlockLesen then Lesetext:=leseblock(name,suche,neu)
  else Lesetext:=leseReadln(name,suche,neu);
end;

{
function lesetext(name:string;var suche:searchrec;var neu:boolean):boolean;
 Unfertig
var f:file;
    akt:ptex;
    n,zeilemsb,zeilelsb:word;
    ok:boolean;
    hilf:PTex;
    ersteslesen:boolean;
    dir:dirstr;
    ext:extstr;
    buf:string;
    blo:pointer;

  procedure ersetzte(c:char;s:string;var buf:string);
  var pos8:byte;
  begin
    pos8:=pos(c,buf);
    while pos8>0 do begin
      insert(s,buf,succ(pos8));
      delete(buf,pos8,1);
      pos8:=pos(c,buf);
    end;
  end;

begin
  y:=0;
  line:=0;
  col:=0;
  aktbild:=0;
  zeilengesamt:=0;
  FSplit(name,dir,suche.name,ext);
  suche.name:=suche.name+'.'+ext;
  ersteslesen:=neu;
  if neu then begin
    findfirst(name,archive,suche);
    neu:=false;
  end else begin
    n:=0;
    while (tex<>nil) and (tex^.s[n]<>nil) do begin
      freemem(tex^.s[n],succ(length(tex^.s[n]^)));
      inc(n);
      if n>maxzeile then begin
        n:=0;
        hilf:=tex;
        tex:=tex^.next;
        dispose(hilf);
      end;
    end;
    if tex<>nil then dispose(tex);
    findnext(suche);
  end;
  if doserror=0 then begin
    lesetext:=true;
    textinfo.name:=suche.name;
    textinfo.grose:=suche.size;
    unpacktime(suche.time,textinfo.datumzeit);
    assign(f,dir+suche.name);
    reset(f);
    new(tex);
    akt:=tex;
    akt^.start:=0;
    zeilemsb:=0;
    zeilelsb:=0;
    ok:=true;
    if suche.size>65536 then gro:=65536 else gro:=suche.size;
    getmem(blo,gro);
    while (not eof(f)) and (maxavail>256) and ok do begin
      blockread(f,blo^);
      n:=0;
      while n<gro do begin
        l:=0;
        tab:=0;
        while (blo^[n]<>13) and (n<gro) and (l<255-tab*8) do begin
          if blo^[n]=8 then inc(tab);
          inc(l);
          inc(n);
        end;
        ersetzte(#9,'        ',buf);
        getmem(akt^.s[zeilelsb],succ(length(buf)));
        akt^.s[zeilelsb]^:=buf;
        inc(zeilengesamt);
        inc(zeilelsb);
        if zeilelsb>maxzeile then begin
          akt^.maxzeile:=maxzeile;
          zeilelsb:=0;
          inc(zeilemsb);
          if maxavail>sizeof(akt^) then begin
            new(akt^.next);
            akt:=akt^.next;
            akt^.start:=zeilemsb;
            ok:=true;
          end else ok:=false;
        end;
      end;
    end;
    akt^.maxzeile:=pred(zeilelsb);
    textinfo.zeilen:=zeilengesamt;
    if akt^.maxzeile<ytextnorm then begin
      akt^.maxzeile:=ytextnorm;
      zeilengesamt:=26;
    end;
    akt^.next:=nil;
    for n:=zeilelsb to maxzeile do akt^.s[n]:=nil;
    freemem(blo,gro);
  end else begin
    if ersteslesen then error('Text nicht gefunden');
    lesetext:=false;
  end;
end;
}

procedure printtoscreen(col,line:integer;attrib:word;s:string);
var l,n:byte;
begin
  l:=length(s);
  if l+col>=xtextmax then l:=pred(xtextmax-col);
  for n:=0 to pred(l) do memw[StartSegment:(line*xtextmax+col+n) shl 1]:=(attrib shl 8)+byte(s[succ(n)]);
end;

procedure print(col,line:integer;attrib:word;s:string;toscreen:boolean);
var l,n,bildline:byte;
begin
  l:=length(s);
  if l+col>=xtextmax then l:=xtextmax-col;
  if line+aktbild>=ytextmax then bildline:=line+aktbild-ytextmax else bildline:=line+aktbild;
  if l>0 then for n:=0 to pred(l) do bildpuf[bildline,n]:=(attrib shl 8)+byte(s[succ(n)]);
  for n:=l to pred(xtextmax) do bildpuf[bildline,n]:=(attrib shl 8);
  if toscreen then move(bildpuf[bildline],mem[StartSegment:(line*xtextmax+col) shl 1],2*xtextmax);
end;

procedure printStatus(col:byte;attrib:word;s:string);
var buf:array[1..80] of word;
    l,n:byte;
begin
  l:=length(s);
  if col+l>80 then dec(l,col+l-80);
  for n:=1 to l do buf[n]:=(attrib shl 8)+byte(s[n]);
  move(buf,mem[StatusStartSegment:col shl 1],2*l);
end;


procedure zeigetext(beg,ende:longint;toscreen:boolean);
var akt:Ptex;
    msb,n:word;
    l,attrib:byte;
    lsb,da,de:longint;
begin
  da:=druckanfang-y;
  de:=druckende-y;
  lsb:=y mod maxzeile;
  msb:=y div maxzeile;
  akt:=tex;
  while (akt^.start<>msb) and (akt<>nil) do akt:=akt^.next;
  if akt=nil then error('Falsche Textstelle 3');
  for n:=beg-y to ende-y do begin
    if lsb+n=maxzeile then begin
      dec(lsb,maxzeile);
      akt:=akt^.next;
      if akt=nil then error('Falsche Textstelle 4');
    end;
    if (n>=da) and (n<=de) then attrib:=liesopt.markiertattribut
    else attrib:=liesopt.textattribut;
    if akt^.s[lsb+n]<>nil then
      print(0,n,attrib,akt^.s[lsb+n]^,toscreen)
    else print(0,n,attrib,'',toscreen)
  end;
end;

procedure movewindow;
var ein,richtung:char;
    pan:boolean;
    anz:byte;
    z,gesch,scrol:word;

  procedure cursorsethohe(ya,ye:byte);
  begin
    port[$3d4]:=$A;
    port[$3d5]:=ya;
    port[$3d4]:=$b;
    port[$3d5]:=ye;
  end;

  procedure cursorsetpos(x,y:byte);
  var rec:registers;
  begin
    with rec do begin
      ah:=2;
      dh:=succ(y);
      dl:=x;
      bh:=0;
      intr($10,rec);
    end;
  end;

  procedure posneu;
  var pos:word;
      cy:byte;
  begin
    pos:=(24*16*y) div (zeilengesamt-24)+ line;
    cursorsetpos(79+(col div 9),pos div 16);
    cy:=pos mod 16;
    cursorsethohe(cy,cy);
  end;

  procedure neuanzeigen;
  type Tpoint=record
                case boolean of
                  true:(p:pointer);
                  false:(ofs,segm:word);
              end;
  var leng,off:word;
      point:TPoint;
  begin
    pantext(col,line);
    posneu;
    {move(bildpuf[aktbild],mem[StartSegment:$0000],2*xtextmax*(ytextmax-aktbild));}
    leng:=xtextmax*(ytextmax-aktbild);
    point.p:=@bildpuf[aktbild];
    asm
      push ds
      mov cx,leng
      mov ax,point.segm
      mov ds,ax
      mov si,point.ofs
      mov ax,StartSegment
      mov es,ax
      xor di,di
      repnz
      movsw
      pop ds
    end;
    if aktbild<>0 then begin
      {move(bildpuf[0],mem[StartSegment:2*xtextmax*(ytextmax-aktbild)],2*xtextmax*aktbild);}
      leng:=xtextmax*aktbild;
      point.p:=@bildpuf[0];
      off:=2*xtextmax*(ytextmax-aktbild);
      asm
        push ds
        mov cx,leng
        mov ax,point.segm
        mov ds,ax
        mov si,point.ofs
        mov ax,StartSegment
        mov es,ax
        mov di,off
        repnz
        movsw
        pop ds
      end;
    end;
    pan:=false;
    
  end;

  procedure rollrunter(anz:byte);
  begin
    inc(aktbild,anz);
    if aktbild>=ytextmax then dec(aktbild,ytextmax);
    zeigetext(y+ytextmax-anz,y+ytextmax-1,onlybuf);
    neuanzeigen;
  end;

  procedure rollhoch(anz:byte);
  var sin,din,leng,ffset:word;
  begin
    if aktbild<anz then inc(aktbild,ytextmax);
    dec(aktbild,anz);
    zeigetext(y,y+anz,onlybuf);
    neuanzeigen;
  end;

  procedure verschieben;
  begin
    if col<0 then col:=0;
    if col>colmax then col:=colmax;
    pan:=true;
    if line>0 then begin
      if line>=linemax then begin
        anz:=line div linemax;
        if y+anz+ytextnorm<zeilengesamt then begin
          inc(y,anz);
          line:=line mod linemax;
          if liesopt.zeilenpause then richtung:=' ';
          rollrunter(anz);
        end else begin
          line:=15;
          richtung:=' ';
        end;
      end;
    end else begin
      while line<0 do begin
        if y>0 then begin
          dec(y);
          inc(line,linemax);
          if liesopt.zeilenpause then richtung:=' ';
          anz:=1;
        end else begin
          line:=0;
          if y<>0 then begin
            anz:=y;
            y:=0;
          end else anz:=0;
        end;
        rollhoch(anz);
      end;
    end;
    if pan then begin
      pantext(col,line);
      posneu;
    end;
  end;

  procedure fenster(x1,y1,x2,y2:byte);
  var buf:string;
      n:byte;
  begin
    zeigetext(y,y+pred(ytextmax),bufandscreen);
    buf:='';
    for n:=1 to x2-x1 do buf:=buf+'';
    buf:=buf+'';
    printtoscreen(x1,y1,liesopt.menuattribut,buf);
    buf:='';
    for n:=1 to x2-x1 do buf:=buf+' ';
    buf:=buf+'';
    for n:=1 to pred(y2-y1) do printtoscreen(x1,y1+n,liesopt.menuattribut,buf);
    buf:='';
    for n:=1 to x2-x1 do buf:=buf+'';
    buf:=buf+'';
    printtoscreen(x1,y2,liesopt.menuattribut,buf);
  end;

  procedure hilfe;
  var buf:string[10];
      xv:byte;
  begin
    xv:=col div 9;
    fenster(10+xv,1,70+xv,17);
    printtoscreen(13+xv, 3,liesopt.menuattribut,'            LIES 1.0 (c) 6.92 Florian Schreck          ');

    printtoscreen(13+xv, 5,liesopt.menuattribut,'Name:               Gre:         Byte  Zeilen:       ');
    printtoscreen(13+xv, 6,liesopt.menuattribut,'Erstellungsdatum:   .  .      Erstellungsuhrzeit:   :  ');

    printtoscreen(13+xv, 8,liesopt.menuattribut,'Position:  Zeile:        Spalte:                       ');

    printtoscreen(13+xv,10,liesopt.menuattribut,'F1      Hilfe                         ');
    printtoscreen(13+xv,11,liesopt.menuattribut,'F2      Suchen                     -> ');
    printtoscreen(13+xv,12,liesopt.menuattribut,'F3      Bereich whlen und Drucken -> ');
    printtoscreen(13+xv,13,liesopt.menuattribut,'F4      Farben                     -> ');
    printtoscreen(13+xv,14,liesopt.menuattribut,'F5      Steuerung und Lesemodus    -> ');
    printtoscreen(13+xv,15,liesopt.menuattribut,'O       Optionen abspeichern          ');
    printtoscreen(19+xv, 5,liesopt.infoattribut,Textinfo.name);
    str(textinfo.grose:7,buf);
    printtoscreen(40+xv,5,liesopt.infoattribut,buf);
    str(textinfo.zeilen:6,buf);
    printtoscreen(62+xv,5,liesopt.infoattribut,buf);
    str(textinfo.datumzeit.day:2,buf);
    printtoscreen(31+xv,6,liesopt.infoattribut,buf);
    str(textinfo.datumzeit.month:2,buf);
    printtoscreen(34+xv,6,liesopt.infoattribut,buf);
    str(textinfo.datumzeit.year:4,buf);
    printtoscreen(37+xv,6,liesopt.infoattribut,buf);
    str(textinfo.datumzeit.hour:2,buf);
    printtoscreen(63+xv,6,liesopt.infoattribut,buf);
    str(textinfo.datumzeit.min:2,buf);
    printtoscreen(66+xv,6,liesopt.infoattribut,buf);
    str(succ(y):6,buf);
    printtoscreen(31+xv,8,liesopt.infoattribut,buf);
    str(succ(col div 9):3,buf);
    printtoscreen(45+xv,8,liesopt.infoattribut,buf);
    {-----------------------------------------------------------}
    {                                                           }
    {              LIES (c) 6.92 Florian Schreck                }
    {                                                           }
    {  Name: 12345678.txt  Gre: 1234567 Byte  Zeilen: 123456  }
    {  Erstellungsdatum: dd.mm.jjjj  Erstellungsuhrzeit: hh:mm  }
    {                                                           }
    {  Position:  Zeile: yy Spalte: xx                          }
    {                                                           }
    {  F1      Hilfe                                            }
    {  F2      Suchen                     ->                    }
    {  F3      Bereich whlen und Drucken ->                    }
    {  F4      Farben                     ->                    }
    {  F5      Steuerung und Lesemodus    ->                    }
    {  O       Optionen abspeichern                             }
    {                                                           }
    {-----------------------------------------------------------}
    repeat until keypressed;
  end;

  procedure suchen;
  var buf:string;
      xv,yv:byte;
      ein:char;
      suchstart,suchrundestart,aktfund:longint;
  
  const fundzahler:word=0;

    procedure info;
    begin
      if groskleinbeacht
      then printtoscreen(xv+20,yv+6,liesopt.infoattribut,'unter')
      else printtoscreen(xv+20,yv+6,liesopt.infoattribut,'ohne ');
      if vor then printtoscreen(xv+13,yv+7,liesopt.infoattribut,'Vorwrts ')
             else printtoscreen(xv+13,yv+7,liesopt.infoattribut,'Rckwrts');
    end;

    procedure menu(gef:byte);
    begin
      fenster(xv,yv,70+xv,11+yv);
      case gef of
        0:printtoscreen(xv+20,yv+2,liesopt.menuattribut,'Suchbegriff nicht gefunden');
        1:printtoscreen(xv+24,yv+2,liesopt.menuattribut,'. Auftreten in Zeile');
        2:printtoscreen(xv+28,yv+2,liesopt.menuattribut,'Suchen');
      end;
      printtoscreen(xv+5,yv+4,liesopt.menuattribut,'Gebe den Suchbegriff ein');

      printtoscreen(xv+5,yv+6,liesopt.menuattribut,'F1      Suchen ohne  Beachtung von Gro- und Klein.');
      printtoscreen(xv+5,yv+7,liesopt.menuattribut,'F2');
      printtoscreen(xv+5,yv+8,liesopt.menuattribut,'<    Starte/Wiederhole das Suchen');
      printtoscreen(xv+5,yv+9,liesopt.menuattribut,'ESC     Beende das Suchen');
      {-----------------------------------------------------------}
      {                                                           }
      {                         Suchen                            }
      {                                                           }
      {  Gebe den Suchbegriff ein >                            <  }
      {                                                           }
      {  F1      Suchen ohne  Beachtung von Gro- und Klein.      }
      {  F2      Vorwrts                                         }
      {  <    Starte/Wiederhole das Suchen                     }
      {  ESC     Beende das Suchen                                }
      {                                                           }
      {-----------------------------------------------------------}
      if gef=1 then begin
        str(succ(aktfund),buf);
        printtoscreen(xv+45,yv+2,liesopt.menuattribut,buf);
        str(fundzahler:4,buf);
        printtoscreen(xv+20,yv+2,liesopt.menuattribut,buf);
      end;
      printtoscreen(xv+32,yv+4,liesopt.infoattribut,'>                            <');
      if search<>'' then printtoscreen(xv+33,yv+4,liesopt.infoattribut,search);
      info;
      cursorsethohe(0,15);
      cursorsetpos(xv+33+length(search),yv+4);
    end;

    function suchenachstes:boolean;
    var akt:Ptex;
        msb:word;
        poss,zeile:byte;
        lsb,aktpos:longint;
        gefunden:boolean;
        searchbuf:string[25];

      procedure anderattrib(x,y,l,a:byte);
      var n:word;
      begin
        for n:=(y*xtextmax+pred(x)) to (y*xtextmax+x+l-2) do begin
          mem[StartSegment:succ(2*n)]:=a;
        end;
      end;

      procedure upstring(e:string;var a:string);
      var n:byte;
      begin
        a:='';
        for n:=1 to length(e) do a:=a+upcase(e[n]);
      end;

    begin
      lsb:=suchstart mod maxzeile;
      msb:=suchstart div maxzeile;
      akt:=tex;
      while (akt^.start<>msb) and (akt<>nil) do akt:=akt^.next;
      if akt=nil then error('Falsche Textstelle 1');
      aktpos:=suchstart;
      gefunden:=false;
      if not groskleinbeacht then upstring(search,searchbuf);
      repeat
        if not groskleinbeacht then begin
          upstring(akt^.s[lsb]^,buf);
          poss:=pos(searchbuf,buf);
        end else poss:=pos(search,akt^.s[lsb]^);
        if poss>0 then begin
          inc(fundzahler);
          gefunden:=true;
          aktfund:=msb*maxzeile+lsb;
          if vor then suchstart:=succ(aktfund) else suchstart:=pred(aktfund);
          if suchstart<0 then suchstart:=pred(zeilengesamt) else
          if suchstart>=zeilengesamt then suchstart:=0;
          y:=aktfund-11;
          if y>zeilengesamt-ytextmax then begin
            zeile:=aktfund-zeilengesamt+ytextmax;
            y:=zeilengesamt-ytextmax;
          end else if y<0 then begin
            y:=0;
            zeile:=aktfund;
          end else zeile:=11;
          if (zeile <13) then yv:=zeile+2 else yv:=zeile-12;
          zeigetext(y,y+pred(ytextmax),bufandscreen);
          anderattrib(poss,zeile,length(search),liesopt.markiertattribut);
        end else begin
          if vor then begin
            inc(aktpos);
            if aktpos>zeilengesamt then begin
              fundzahler:=0;
              akt:=tex;
              msb:=0;
              lsb:=0;
              aktpos:=0;
            end else begin
              inc(lsb);
              if lsb>maxzeile then begin
                inc(msb);
                akt:=akt^.next;
                if akt=nil then error('Falsche Textstelle 2');
                lsb:=0;
              end;
            end;
          end else begin
            dec(aktpos);
            if aktpos<0 then begin
              akt:=tex;
              while akt^.next<>nil do akt:=akt^.next;
              msb:=akt^.start;
              lsb:=akt^.maxzeile;
              aktpos:=zeilengesamt;
              fundzahler:=0;
            end else begin
              dec(lsb);
              if lsb<0 then begin
                dec(msb);
                akt:=tex;
                while (akt^.start<>msb) and (akt<>nil) do akt:=akt^.next;
                if akt=nil then error('Falsche Textstelle 5');
                lsb:=0;
              end;
            end;
          end;
        end;
      until gefunden or (suchrundestart=aktpos);
      suchenachstes:=gefunden;
    end;

  begin
    suchstart:=y;
    suchrundestart:=y;
    xv:=col div 9+5;
    yv:=succ(ytextnorm div 4);
    menu(2);
    repeat
      repeat until keypressed;
      ein:=readkey;
      if keypressed then begin
        ein:=readkey;
        case ein of
          #59:groskleinbeacht:=not groskleinbeacht;
          #60:vor:=not vor;
        end;
        if ein in [#59,#60] then begin
          info;
          fundzahler:=0;
          suchrundestart:=y;
        end;
      end else begin
        if ein=#13 then menu(byte(suchenachstes)) else begin
          fundzahler:=0;
          suchrundestart:=y;
          if (ein=#8) then begin
            if (length(search)>0) then begin
              delete(search,length(search),1);
              printtoscreen(xv+33+length(search),yv+4,liesopt.infoattribut,' ');
              cursorsetpos(xv+33+length(search),yv+4);
            end;
          end else begin
            if (length(search)<29) and (ein<>#27) then begin
              search:=search+ein;
              printtoscreen(xv+32+length(search),yv+4,liesopt.infoattribut,ein);
              cursorsetpos(xv+33+length(search),yv+4);
            end;
          end;
        end;
      end;
    until ein=#27;
    zeigetext(y,y+pred(ytextmax),bufandscreen);
    posneu;
  end;

  procedure drucken;
  var buf:string[10];
      xv:byte;
  begin
    xv:=col div 9;
    fenster(10+xv,1,60+xv,9);
    printtoscreen(13+xv, 3,liesopt.menuattribut,'  Bereich whlen und Drucken');

    printtoscreen(13+xv, 5,liesopt.menuattribut,'  A       Anfang');
    printtoscreen(13+xv, 6,liesopt.menuattribut,'  E       Ende');
    printtoscreen(13+xv, 7,liesopt.menuattribut,'  D       Drucken');
    {------------------------------}
    {  Bereich whlen und Drucken  }
    {                              }
    {  A       Anfang              }
    {  E       Ende                }
    {  D       Drucken             }
    {                              }
    {------------------------------}
    repeat until keypressed;
  end;


  procedure farben;
  var buf:string[10];
      xv:byte;
  begin
    xv:=col div 9;
    fenster(10+xv,1,60+xv,14);
    printtoscreen(13+xv, 3,liesopt.menuattribut,'       Farben einstellen');

    printtoscreen(13+xv, 5,liesopt.menuattribut,'  Y       Vordergrund');
    printtoscreen(13+xv, 6,liesopt.menuattribut,'  X       Hintergrund');
    printtoscreen(13+xv, 7,liesopt.menuattribut,'  C       Markiert Vordergrund');
    printtoscreen(13+xv, 8,liesopt.menuattribut,'  V       Markiert Hintergrund');
    printtoscreen(13+xv, 9,liesopt.menuattribut,'  F       Menu Vordergrund');
    printtoscreen(13+xv,10,liesopt.menuattribut,'  G       Menu Hintergrund');
    printtoscreen(13+xv,11,liesopt.menuattribut,'  ,       Info Vordergrund');
    printtoscreen(13+xv,12,liesopt.menuattribut,'  .       Info Hintergrund');
    {--------------------------------}
    {                                }
    {       Farben einstellen        }
    {                                }
    {  Y       Vordergrund           }
    {  X       Hintergrund           }
    {  C       Markiert Vordergrund  }
    {  V       Markiert Hintergrund  }
    {  F       Menu Vordergrund      }
    {  G       Menu Hintergrund      }
    {  ,       Info Vordergrund      }
    {  .       Info Hintergrund      }
    {--------------------------------}
    repeat until keypressed;
  end;


  procedure steuerung;
  var buf:string[10];
      xv:byte;
  begin
    xv:=col div 9;
    fenster(10+xv,1,60+xv,22);
    printtoscreen(13+xv, 3,liesopt.menuattribut,'              Steuerung und Lesemodus');

    printtoscreen(15+xv, 5,liesopt.menuattribut,#24#25#26#27+'    Richtung');
    printtoscreen(13+xv, 6,liesopt.menuattribut,' 1..9,0QW Geschwindigkeit');
    printtoscreen(13+xv, 7,liesopt.menuattribut,'  +       Geschwindigkeit erhhen');
    printtoscreen(13+xv, 8,liesopt.menuattribut,'  -       Geschwindigkeit verringern');
    printtoscreen(13+xv,10,liesopt.menuattribut,'  P       Pause nach jeder Zeile');
    printtoscreen(13+xv,11,liesopt.menuattribut,'  PgUp    hochblttern');
    printtoscreen(13+xv,12,liesopt.menuattribut,'  PgDwn   runterblttern');
    printtoscreen(13+xv,13,liesopt.menuattribut,'  Home    Textanfang');
    printtoscreen(13+xv,14,liesopt.menuattribut,'  End     Textende');
    if liesopt.UseJoy then
    printtoscreen(13+xv,16,liesopt.menuattribut,'  J       Joystick: zur Zeit an')
    else printtoscreen(13+xv,16,liesopt.menuattribut,'  J       Joystick: zur Zeit aus');
    printtoscreen(13+xv,17,liesopt.menuattribut,'  K       Joystick kalibrieren');
    if liesopt.UseMaus then
    printtoscreen(13+xv,18,liesopt.menuattribut,'  M       Maus: zur Zeit an')
    else printtoscreen(13+xv,18,liesopt.menuattribut,'  M       Maus: zur Zeit aus');

    if liesopt.Blocklesen then
    printtoscreen(13+xv,20,liesopt.menuattribut,'  L       Lesemodus: zur Zeit Blockread')
    else printtoscreen(13+xv,20,liesopt.menuattribut,'  L       Lesemodus: zur Zeit Readln');
    {------------------------------------------------}
    {                                                }
    {              Steuerung und Lesemodus           }
    {                                                }
    {  #24#25#26#27 Richtung                         }
    {  1..9,0QW Geschwindigkeit                      }
    {  +       Geschwindigkeit erhhen               }
    {  -       Geschwindigkeit verringern            }
    {  P       Pause nach jeder Zeile                }
    {  PgUp    hochblttern                          }
    {  PgDwn   runterblttern                        }
    {  Home    Textanfang                            }
    {  End     Textende                              }
    {                                                }
    {  J       Joystick an bzw. aus                  }
    {  K       Joystick kalibrieren                  }
    {  M       Maus an bzw. aus                      }
    {                                                }
    {  L       Lesemodus (Readln, BlockRead)         }
    {                                                }
    {------------------------------------------------}
    repeat until keypressed;
  end;

  procedure kalibrieren;
  var xv,n,m:byte;
  begin
    if joystickvorhanden(0) then joy:=0
    else if joystickvorhanden(1) then joy:=1 else joy:=2;
    if joy<>2 then begin
      xv:=col div 9;
      fenster(10+xv,1,45+xv,6);
      printtoscreen(13+xv, 3,liesopt.menuattribut,' Bewege den Joystick nach links');
      printtoscreen(13+xv, 4,liesopt.menuattribut,' oben und drcke einen Knopf !');
      if initjoystick(joy,0) then begin
        fenster(10+xv,1,45+xv,6);
        printtoscreen(13+xv, 3,liesopt.menuattribut,' Bewege den Joystick nach rechts');
        printtoscreen(13+xv, 4,liesopt.menuattribut,' unten und drcke einen Knopf !');
        repeat until (not buttonpressed) and
                     (abs(Paddle(joy*2)-maxpos[joy,0,0])>20) and
                     (abs(Paddle(succ(joy*2))-maxpos[joy,1,0])>20);
        if initjoystick(joy,1) then begin
          liesopt.usejoy:=true;
          fenster(10+xv,1,20+xv,5);
          printtoscreen(13+xv, 3,liesopt.menuattribut,' Danke!');
          for n:=0 to 1 do for m:=0 to 1 do liesopt.joykalib[n,m]:=maxpos[joy,n,m];
          delay(500);
          exit;
        end;
      end
    end;
    xv:=col div 9;
    fenster(10+xv,1,40+xv,5);
    printtoscreen(13+xv, 3,liesopt.menuattribut,' Kein Joystick gefunden ! ');
  end;

  procedure neuattribut;
  var n:word;
  begin
    for n:=0 to pred(2*xtextmax*ytextmax) do begin
      inc(n);
      if mem[StartSegment:n]=altmenuattribut then mem[StartSegment:n]:=liesopt.menuattribut;
      if mem[StartSegment:n]=altinfoattribut then mem[StartSegment:n]:=liesopt.infoattribut;
    end;
    altinfoattribut:=liesopt.infoattribut;
    altmenuattribut:=liesopt.menuattribut;
  end;

  procedure Optsichern;
  const maxbuf=10;
  var buf:array[1..maxbuf] of pointer;
      suche:searchrec;
      n:word;
      q,z:file;
      result:word;
      grose:longint;
      xv,bufanz,bufn:byte;
  type chararray=array[0..65500] of char;

    procedure incbufanz;
    begin
      inc(bufanz);
      if bufanz>maxbuf then error('LIES'+'.EXE zu gro');
    end;

    procedure incbufn;
    begin
      inc(bufn);
      if bufn>bufanz then error('Fehler 1');
    end;

  begin
    suche.name:='LIES.EXE';
    findfirst('LIES.EXE',anyfile,suche);
    if doserror=0 then begin
      assign(q,'LIES.EXE');
      reset(q,1);
      grose:=suche.size;
      bufanz:=0;
      if grose>65500 then begin
        incbufanz;
        getmem(buf[bufanz],65500);
        while grose>65500 do begin
          blockread(q,buf[bufanz]^,65500,result);
          if result<>65500 then error('LIES.EXE nicht vollstndig gelesen');
          dec(grose,65500);
        end;
      end;
      incbufanz;
      getmem(buf[bufanz],grose);
      blockread(q,buf[bufanz]^,grose,result);
      close(q);
      if result<>grose then error('LIES.EXE nicht vollstndig gelesen');
      bufn:=0;
      assign(z,'LIES.EXE');
      rewrite(z,1);
      if suche.size>65500 then begin
        while suche.size>65500 do begin
          incbufn;
          blockwrite(z,buf[bufn]^,65500,result);
          if result<>65500 then error('Konnte LIES.EXE nicht vollstndig schreiben');
          dec(suche.size,65500);
        end;
        freemem(buf[bufn],65500);
      end;
      incbufn;
      n:=0;
      while (n<suche.size) and
           ((chararray(buf[bufn]^)[n  ]<>'L') or
            (chararray(buf[bufn]^)[n+1]<>'I') or
            (chararray(buf[bufn]^)[n+2]<>'E') or
            (chararray(buf[bufn]^)[n+3]<>'S') or
            (chararray(buf[bufn]^)[n+4]<>'K') or
            (chararray(buf[bufn]^)[n+5]<>'E') or
            (chararray(buf[bufn]^)[n+6]<>'N') or
            (chararray(buf[bufn]^)[n+7]<>' ') or
            (chararray(buf[bufn]^)[n+8]<>'1') or
            (chararray(buf[bufn]^)[n+9]<>'.') or
            (chararray(buf[bufn]^)[n+10]<>'0')) do inc(n);
      if n=suche.size then error('LIES.EXE: Kennung nicht gefunden');
      move(liesopt,chararray(buf[bufn]^)[pred(n)],sizeof(liesopt));
      blockwrite(z,buf[bufn]^,suche.size,result);
      if result<>suche.size then error('Konnte LIES.EXE nicht vollstndig schreiben');
      freemem(buf[bufn],suche.size);
      close(z);
    end else begin
      xv:=col div 9;
      fenster(10+xv,1,45+xv,5);
      printtoscreen(13+xv, 3,liesopt.menuattribut,'LIES.EXE nicht gefunden !');
    end;
  end;

  procedure home;
  begin
    y:=0;line:=0;col:=0;
    zeigetext(0,pred(ytextmax),bufandscreen);
  end;

  procedure ende;
  begin
    y:=zeilengesamt-ytextnorm;
    line:=0;col:=0;
    zeigetext(y,zeilengesamt,bufandscreen);
  end;

  procedure pgup(dy:word);
  begin
    dec(y,dy);if y<0 then y:=0;
    zeigetext(y,y+pred(ytextmax),bufandscreen);
  end;

  procedure pgdwn(dy:word);
  begin
    inc(y,dy);
    if y>zeilengesamt-ytextnorm then begin
      y:=zeilengesamt-ytextnorm;
      zeigetext(y,zeilengesamt,bufandscreen)
    end else zeigetext(y,y+pred(ytextmax),bufandscreen);
  end;

  procedure steuer(ausy,bereich:longint);

    function hoch(b:real;e:word):word;
    var n:word;
        h:real;
    begin
      h:=1;
      for n:=1 to e do h:=h*b;
      hoch:=round(h);
    end;

  begin
    if abs(ausy)>(bereich div 20) then begin
        if ausy<0 then richtung:=#72 else richtung:=#80;
        ausy:=abs(ausy)*2*33 div bereich;
        {Normiert auf 0..33}
        case ausy of
          0..4:;
          5..19:gesch:=4*hoch(1.5,ausy-3);
          20..31:begin
                   if richtung=#72 then pgup(hoch(1.5,ausy-11)) else pgdwn(hoch(1.5,ausy-11));
                 end;
          else begin
            if richtung=#72 then home else ende;
          end;
        end;
      end;
  end;

  procedure joystickauswerten;
  begin
    if liesopt.usejoy and (joy<2) then
      steuer(paddle(1)-((liesopt.joykalib[1,0]+liesopt.joykalib[1,1]) div 2),
             (liesopt.joykalib[1,1]-liesopt.joykalib[1,0]));
  end;

  procedure mausauswerten;
  var tasten,xpos,ypos:word;
  begin
    if liesopt.usemaus and mouse then begin
      maustastpos(tasten,xpos,ypos);
      steuer(integer(ypos)-100,200);
    end;
  end;

  procedure Drucke;
  var akt:Ptex;
      msb,n:word;
      l,attrib:byte;
      lsb,da,de:longint;
  begin
    lsb:=druckanfang mod maxzeile;
    msb:=druckanfang div maxzeile;
    akt:=tex;
    while (akt^.start<>msb) and (akt<>nil) do akt:=akt^.next;
    if akt=nil then error('Falsche Textstelle');
    for n:=0 to druckende-druckanfang do begin
      if lsb+n=maxzeile then begin
        dec(lsb,maxzeile);
        akt:=akt^.next;
        if akt=nil then error('Falsche Textstelle');
      end;
      if akt^.s[lsb+n]<>nil then writeln(lst,akt^.s[lsb+n]^);
    end;
  end;

  procedure StatusPos(col,line:word);
  var buf:string[6];
  begin
    str(col:3,buf);
    PrintStatus(68,liesopt.infoattribut,buf);
    str(line:6,buf);
    PrintStatus(53,liesopt.infoattribut,buf);
  end;

begin
  line:=0;
  col:=0;
  ein:=' ';
  richtung:=' ';
  gesch:=32;
  z:=0;
  repeat
    repeat
      inc(z,gesch);
      scrol:=z div 32;
      case richtung of
        #75:dec(col,scrol);
        #77:inc(col,scrol);
        #72:dec(line,scrol);
        #80:inc(line,scrol);
      end;
      dec(z,scrol*32);
      verschieben;
      StatusPos(succ(col div 9),succ(y));
      joystickauswerten;
      mausauswerten;
    until keypressed;
    ein:=upcase(readkey);
    if keypressed then begin
      ein:=upcase(readkey);
      if ein in[#72,#75,#77,#80] then richtung:=ein;
      case ein of
        #59:hilfe;
        #60:suchen;
        #61:drucken;
        #62:farben;
        #63:steuerung;
        #45:error('');
        #71:Home;
        #79:Ende;
        #73:pgup(ytextnorm);
        #81:pgdwn(ytextnorm);
      end;
    end else begin
      case ein of
        '+':if (gesch<8193) then inc(gesch,succ(gesch div 8));
        '-':if (gesch>0) then dec(gesch,succ(gesch div 8));
        '1'..'9':gesch:=2 shl (byte(ein)-$31);
        '0':gesch:=1 shl 11;
        'Q':gesch:=1 shl 12;
        'W':gesch:=1 shl 13;
        #13,' ':richtung:=' ';
        'P':liesopt.Zeilenpause:=not liesopt.Zeilenpause;
        'J':liesopt.usejoy:=not liesopt.usejoy;
        'L':liesopt.BlockLesen:=not liesopt.BlockLesen;
        'M':if mouse then liesopt.usemaus:=not liesopt.usemaus;
        'K':kalibrieren;
        'O':OptSichern;
        'Y':liesopt.textattribut:=(liesopt.textattribut and $F0) or (succ(liesopt.textattribut) and $0f);
        'X':liesopt.textattribut:=(liesopt.textattribut and $0F) or ((succ(liesopt.textattribut shr 4) shl 4) and $F0);
        'C':liesopt.markiertattribut:=(liesopt.markiertattribut and $F0) or (succ(liesopt.markiertattribut) and $0f);
        'V':liesopt.markiertattribut:=(liesopt.markiertattribut and $0F) or
            ((succ(liesopt.markiertattribut shr 4) shl 4) and $F0);
        'F':liesopt.menuattribut:=(liesopt.menuattribut and $F0) or (succ(liesopt.menuattribut) and $0f);
        'G':liesopt.menuattribut:=(liesopt.menuattribut and $0F) or ((succ(liesopt.menuattribut shr 4) shl 4) and $F0);
        ',':liesopt.infoattribut:=(liesopt.infoattribut and $F0) or (succ(liesopt.infoattribut) and $0f);
        '.':liesopt.infoattribut:=(liesopt.infoattribut and $0F) or ((succ(liesopt.infoattribut shr 4) shl 4) and $F0);
        'A':druckanfang:=y;
        'E':druckende:=y+ytextnorm;
        'D':Drucke;
      end;
      case ein of
        'X','Y','C','V','A','E':zeigetext(y,y+pred(ytextmax),bufandscreen);
        'F','G',',','.':NeuAttribut;
      end;
      case ein of
        'J','M','L':steuerung;
      end;
    end;
  until ein=#27;
end;

procedure lese;
var n:byte;

  procedure StatusAnzeigen;
  var buf:string[7];
  begin                                { F1               12345678.123        1234567        123456         123        }
    printStatus(0,liesopt.menuattribut,'    Hilfe  Name:              Gre:         Zeile:        Spalte:             ');
    PrintStatus(1,liesopt.infoattribut,'F1');
    PrintStatus(18,liesopt.infoattribut,TextInfo.Name);
    str(Textinfo.grose:7,buf);
    PrintStatus(38,liesopt.infoattribut,buf);
    PrintStatus(58,liesopt.infoattribut,'0');
    PrintStatus(70,liesopt.infoattribut,'0');
  end;

begin
  for n:=1 to paramcount do begin
    neu:=true;
    suche.name:=paramstr(n);
    while lesetext(paramstr(n),suche,neu) do begin
      zeigetext(0,pred(ytextmax),bufandscreen);
      StatusAnzeigen;
      movewindow;
    end;
  end
end;

procedure initinput;
var tasten:word;
begin
  if joystickvorhanden(0) then joy:=0
  else if joystickvorhanden(1) then joy:=1;
  mausinit(tasten);
  mouse:=tasten>0;
  if mouse then begin
    mausminmaxx(0,200);
    mausminmaxy(0,200);
    maussetpos(100,100);
  end;
end;

begin
  altmenuattribut:=liesopt.menuattribut;
  altinfoattribut:=liesopt.infoattribut;
  initinput;
  if paramcount>0 then begin
    linemax:=memw[$40:$85];
    colmax:=(xtextmax-xtextnorm)*9;
    if expandtext(xtextmax,ytextmax,160) then begin
      SetLineComp(16*24);
      lese;
      SetLineComp(0);
    end else error('Konnte Panning nicht benutzen!');
    crtreset;
  end else begin
    writeln('Smooth Text Reader (c) Florian Schreck 29.5.1992');
    writeln('LIES Name');
    halt(1);
  end;
end.
