unit panning;

interface
uses crt;
  function expandtext(px,py:integer;AVersatz:word):boolean;
  function pantext(px,py:integer):boolean;

  procedure SetLineComp(ALineComp:Word);

implementation
const altaddr:word=0;
      Versatz:word=0;

  function expandtext(px,py:integer;AVersatz:word):boolean;
  var h:boolean;
  begin
    asm
      push es
      mov  ax,$40
      mov  es,ax
      mov  al,ah
      mov  bx,px
      or   bx,py
      jge  @mexp
      jmp  @raus
@mexp:xor  al,al
      mov  bx,80  {textcolnorm}
      cmp  bx,px
      jge  @etraus
      mov  bx,25  {textrownorm}
      cmp  bx,py
      jge  @etraus
      mov  ax,px
      mov  bx,py
      mul  bx
      mov  cx,ax
      dec  ax
      and  ax,$8000
      or   dx,ax
      jnz  @etraus
      dec  bx
      or   bh,bh
      jnz  @etraus
      mov  es:[$4c],cx {bufferlength}
      mov  ax,px
      mov  es:[$4a],ax {columns}
      mov  es:[$84],bl {rows_m1}
      shr  ax,1
      mov  ah,al
      mov  al,19
      mov  dx,es:[$63] {crtc}
      out  dx,ax
      mov  al,1
      jmp  @raus
@etraus:
      xor  al,al
@raus:mov h,al
      pop  es
    end;
    expandtext:=h;
    altaddr:=0;
    Versatz:=AVersatz;
  end;

  function pantext(px,py:integer):boolean;
  var h:boolean;
  begin
    asm
      push es
      mov  ax,$40
      mov  es,ax
      mov  al,ah
      mov  bx,px
      or   bx,py
      jge  @pant
      jmp  @raus
@pant:mov  ax,px
      xor  dx,dx
      mov  cx,9 {pixelperchar}
      div  cx
      mov  bh,dl
      mov  bl,al
      dec  bh
      jge  @not9
      mov  bh,8
@not9:add  ax,80 {textcolnorm}
      cmp  ax,es:[$4a] {columns}
      jg   @praus
      mov  ax,py
      xor  dx,dx
      mov  cx,es:[$85] {slinesperchar}
      div  cx
      or   dh,ah
      jz   @tokay
      jmp  @praus
@tokay:mov ch,dl
      mov  cl,al
      add  ax,24 {textrownorm-1}
      cmp  ax,es:[$84] {rows_m1}
      jg   @praus
      mov  al,cl
      xor  ah,ah
      mul  word ptr es:[$4a] {columns}
      xor  dx,dx
      mov  dl,bl
      add  ax,dx

      add  ax,Versatz

      mov  bl,al
      mov  dx,es:[$63] {crtc}
      add  dl,6
@loc1:in   al,dx   {waitsync}
      test al,8
      jz  @loc1
@loc2:in   al,dx
      test al,8
      jnz   @loc2
      cli
      sub  dl,6   {crtc}


      mov  al,12
      out  dx,ax  {start addr high}
      inc  al
      mov  ah,bl
      out  dx,ax  {start addr low}
      mov  ah,ch

      
      push ax
      sub ax,altaddr
      cmp ax,128
      jb @norow
      add  dl,6
@loc3:in   al,dx   {waitsync}
      test al,8
      jz   @loc3
@loc4:in   al,dx
      test al,8
      jnz  @loc4
      sub  dl,6
@norow:pop  ax
      MOV  altaddr,AX
      
      mov  al,8   {preset row scan}
      out  dx,ax
      mov  dl,$c0
      mov  al,$33
      out  dx,al  {horiz pix pan reg}
      mov  al,bh
      out  dx,al

      sti
      mov  al,1
      jmp  @raus
@praus:
      xor  al,al
@raus:mov h,al
       pop  es
    end;
{    writeln(lst,xpan:4,ypan:4,ad:6);}
    {if ypan=15 then begin write(^G);delay(400); end;}
    pantext:=h;
  end;

procedure SetLineComp(ALineComp:Word);
begin
  asm
    mov bx,ALineComp;

    mov dx,$3d4
    mov al,$18
    mov ah,bl
    out dx,ax

    mov ah,bh
    and ah,1
    shl ah,4
    mov al,7
    out dx,al
    inc dx
    in al,dx
    and al,$ef
    or al,ah
    out dx,al
    dec dx

    mov ah,bh
    and ah,2
    shl ah,5
    mov al,9
    out dx,al
    inc dx
    in al,dx
    and al,$bf
    or al,ah
    out dx,al
  end;
end;

end.